import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Box extends Actor
{
    double d, sf, ss, t, ss1, ss2, ss3, ss4, ss5, ss6, ss7, ss8, ss9, ss10, ss11;
    int dmax = 800;

    boolean moved;
    int i = 1;
    int m = (int)d%dmax + 1;
    int bi;
    
    public Box(double speed, int boxIndex)
    {
        sf = speed;
        bi = boxIndex;

        GreenfootImage box;
        box = new GreenfootImage(20, 20);
        box.setColor(Color.GREEN);
        box.fill();
        setImage(box);
    }
    
    public void act()
    {
        if (!moved && ((MyWorld)getWorld()).mode == 1) moveBox(sf);
        if (!moved && ((MyWorld)getWorld()).getMode() == 2) moveBoxSmoothStep(sf);
        if (!moved && ((MyWorld)getWorld()).mode == 3) moveBox1(sf, bi);
    }
    
    public void moveBox1(double sf,  int bi)
    {
        if (d <= dmax)
        {
            d += sf;

            t = d%200 / 200;
            t = t * 2;
            if (t > 1) t = 1 - (t - 1);
            
            ss1 = t;
            ss2 = smoothStep(ss1);
            ss3 = smoothStep(ss2);
            ss4 = smoothStep(ss3);
            ss5 = smoothStep(ss4);
            ss6 = smoothStep(ss5);
            ss7 = smoothStep(ss6);
            ss8 = smoothStep(ss7);
            ss9 = smoothStep(ss8);
            ss10 = smoothStep(ss9);
            ss11 = smoothStep(ss10);
            
            if (bi == 1) ss = t;
            if (bi == 2) ss = ss2;
            if (bi == 3) ss = ss3;
            if (bi == 4) ss = ss4;
            if (bi == 5) ss = ss5;
            if (bi == 6) ss = ss6;
            if (bi == 7) ss = ss7;
            if (bi == 8) ss = ss8;
            if (bi == 9) ss = ss9;
            if (bi == 10) ss = ss10;
            if (bi == 11) ss = ss11;
            
            double px = ss * 760 + 20;
            setLocation((int)px, getY());
        }

        if (d > dmax) d = 0;
    }

    public void moveBox(double sf)
    {
        if (d <= dmax)
        {
            d += sf;
            setLocation((int)d, getY());
        }
        
        if (d >= dmax)
        {
            d += sf;
            m = m + 2 * (int)sf;
 
            setLocation(-m + (int)d , getY());
        }
        
        if (d >= dmax*2)
        {
            d = 0;
            m = 0;
        }
    }
    
    public void moveBoxSmoothStep(double sf)
    {
        if (d <= dmax)
        {

            d += sf;

            double t = d%600 / 600;
            t = t * 6;
            if (t > 1) t = 1 - (t - 1);
            
            double ss = smoothStep(t);
            double px = ss * 600;
            if (d < dmax) setLocation((int)px, getY());
        }

        if (d > dmax)
        {
            d = dmax + 1;
            moved = true;
        }
    }
    
    public double smoothStep(double x)
    {
        return x * x * (3 - 2 * x);
    }
}
