import greenfoot.*;

public class MyWorld extends World
{
    private Box box;
    private int speed;
    private double sf;
    public int mode;
    
    public MyWorld()
    {    
        super(800, 440, 1, false); 
        
        GreenfootImage bg = getBackground();
        bg.setColor(Color.BLACK);
        bg.fill();
        Greenfoot.setSpeed(50);
        Greenfoot.start();
        // addObject(new Box(1),  0, 10);
        
        mode = 3;
        sf = 1;
        addBox2(sf);
    }

    public int getMode() {
        return mode;
    }

    public void act()
    {
        if (Greenfoot.isKeyDown("1"))
        {
            sf = .25;
            removeObjects(getObjects(Box.class));
            addBox1(sf);
            Greenfoot.delay(10);
        }

        if (Greenfoot.isKeyDown("2"))
        {
            sf = .5;
            removeObjects(getObjects(Box.class));
            addBox1(sf);
            Greenfoot.delay(10);
        }

        if (Greenfoot.isKeyDown("3"))
        {
            sf = 1;
            removeObjects(getObjects(Box.class));
            addBox1(sf);
            Greenfoot.delay(10);
        }
        
        if (Greenfoot.isKeyDown("a"))
        {
            mode = 1;
            removeObjects(getObjects(Box.class));
            addBox1(5);
            Greenfoot.delay(10);
        }

        if (Greenfoot.isKeyDown("b"))
        {
            mode = 2;
            removeObjects(getObjects(Box.class));
            addBox1(.5);
            Greenfoot.delay(10);
        }

        if (Greenfoot.isKeyDown("c"))
        {
            mode = 3;
            removeObjects(getObjects(Box.class));
            addBox2(1);
            Greenfoot.delay(10);
        }
    }

    public void addBox2(double sf)
    {
        for (int i=1; i <= 10; i++)
        {
            // double sfn = (double)i * 0.55;
            addObject(new Box(sf, i+1), 20, i*40);
        }
    }

    public void addBox(double sf)
    {
        for (int i=1; i <= 1; i++)
        {
            addObject(new Box(sf, 1), 20, i*40);
        }
    }
    
    public void addBox1(double sf)
    {
        for (int i=1; i <= 10; i++)
        {
            addObject(new Box((double)i * sf, 1), 20, i*40);
        }
    }
}
