import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Box2 extends Actor
{
    float d, sf;
    int dmax = 400;
    GreenfootImage box;
    boolean moved;
    
    public Box2(float speed)
    {
        sf = speed;
        box = new GreenfootImage(20, 20);
        box.setColor(Color.BLACK);
        box.fill();
        setImage(box);
    }
    
    public void act()
    {
        if (!moved) moveBox(sf);
    }
    
    public void moveBox(float sf)
    {
        if (d <= dmax)
        {
            d += sf;

            float t = d%1000 / 1000;
            t = t * 10;
            if (t > 1) t = 1 - (t - 1);
            
            float ss = smoothStep(t);
            float px = ss * 1000;
            if (d < dmax) setLocation((int)px, getY());
        }

        if (d > dmax) {
            d = dmax + 1;
            moved = true;
        }
    }
    
    public float smoothStep(float x)
    {
        return x * x * (3 - 2 * x);
    }
}

